package com.lhcx.c3p0;

import java.sql.CallableStatement;
import java.sql.Connection;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.sql.Types;
import java.util.Iterator;
import java.util.List;

import org.springframework.jdbc.datasource.DataSourceUtils;

import com.lhcx.util.ConvertUtil;
import com.mchange.v2.c3p0.ComboPooledDataSource;

public class C3P0Util {
	private static ComboPooledDataSource dataSource;
	
	/**
	 * 执行oracle SQL语句
	 * 
	 * @param sqlStr
	 *            sql语句
	 * @return String
	 */
	public static String oracleQuery(String sqlStr) {
		String jsonResultStr = "";

		Connection conn = null;
		Statement stmt = null;
		ResultSet rs = null;

		try {
			conn = DataSourceUtils.getConnection(dataSource);
			stmt = conn.createStatement();
			rs = stmt.executeQuery(sqlStr);
			/* 转换为json串 */
			jsonResultStr = ConvertUtil.resultSet2Json(rs);
		} catch (SQLException ex) {
			ex.printStackTrace();
		} finally {
			try {
				if (rs != null) {
					rs.close();
					rs = null;
				}
				if (stmt != null) {
					stmt.close();
					stmt = null;
				}
				if (conn != null) {
					conn.close();
					conn = null;
				}
			} catch (SQLException ex) {
				ex.printStackTrace();
			}
		}
		return jsonResultStr;
	}

	public static String oracleExcePro(String sqlStr, List<String> inputParam) {
		String retStr = "";

		Connection conn = null;
		CallableStatement proc = null;

		try {
			conn = DataSourceUtils.getConnection(dataSource);
			proc = conn.prepareCall(sqlStr);
			Iterator<String> it = inputParam.iterator();
			int iId = 0;
			while (it.hasNext()) {
				iId++;
				String str = it.next();
				proc.setString(iId, str);
			}
			iId++;
			proc.registerOutParameter(iId, Types.VARCHAR);
			proc.execute();
			retStr = proc.getString(iId);

		} catch (SQLException ex) {
			ex.printStackTrace();
		} finally {
			try {
				if (proc != null) {
					proc.close();
					proc = null;
				}
				if (conn != null) {
					conn.close();
					conn = null;
				}
			} catch (SQLException ex) {
				ex.printStackTrace();
			}
		}
		return retStr;
	}

	public void setDataSource(ComboPooledDataSource dataSource) {
		C3P0Util.dataSource = dataSource;
	}

}
